declare global {
	namespace Express {
		interface Request {
			/**
			 * This is a type-safe variant of "req.safeBody".
			 * "req.safeBody" is 'any' by default, which makes it exceptionally difficult
			 * to use in our codebase (due to the strict cadence rules.)
			 */
			safeBody: Record<string, unknown>;
		}
	}
}

export {};
