import { ConstructableBaseEntity } from "../utils/constructable-base-entity";
import { Column, CreateDateColumn, Entity, PrimaryGeneratedColumn } from "typeorm";
import { integer } from "types/misc";

@Entity("event_log")
export class EventLog extends ConstructableBaseEntity {
	@PrimaryGeneratedColumn()
	id!: integer;

	@CreateDateColumn()
	datetime!: Date;

	@Column({ type: "text" })
	system!: string;

	@Column({ type: "text" })
	type!: string;

	@Column({ length: 10 })
	severity!: string;

	@Column({ type: "text" })
	message!: string;

	@Column({ type: "simple-json" })
	details!: Record<string, unknown>;
}
