import { AimeCard } from "../aimedb";
import { ConstructableBaseEntity } from "external/db/utils/constructable-base-entity";
import { Column, Entity, ManyToOne, PrimaryGeneratedColumn, Unique } from "typeorm";
import { integer } from "types/misc";

@Entity()
@Unique(["card", "version", "order"])
export class ChunithmUserRecentRating extends ConstructableBaseEntity {
	@PrimaryGeneratedColumn()
	id!: integer;

	@ManyToOne(() => AimeCard, { eager: true })
	card!: AimeCard;

	@Column()
	version!: integer;

	@Column()
	order!: integer;

	@Column()
	musicId!: integer;

	@Column()
	difficultId!: integer;

	@Column()
	romVersionCode!: integer;

	@Column()
	score!: integer;
}
