import { ConstructableBaseEntity } from "../../utils/constructable-base-entity";
import {
	Entity,
	PrimaryGeneratedColumn,
	Column,
	ManyToOne,
	CreateDateColumn,
	OneToMany,
	Unique,
} from "typeorm";
import { integer } from "types/misc";

@Entity("chunithm_static_events")
@Unique(["version", "eventId"])
export class ChunithmStaticEvent extends ConstructableBaseEntity {
	@PrimaryGeneratedColumn()
	id!: integer;

	@Column()
	version!: integer;

	@Column()
	eventId!: integer;

	@Column()
	type!: integer;

	@Column({ type: "text" })
	name!: string;

	@Column({ type: "datetime", default: () => "CURRENT_TIMESTAMP" })
	startDate!: Date;

	@Column({ type: "boolean", default: true })
	enabled!: boolean;
}

@Entity("chunithm_static_events")
@Unique(["version", "chargeId"])
export class ChunithmStaticCharge extends ConstructableBaseEntity {
	@PrimaryGeneratedColumn()
	id!: integer;

	@Column()
	version!: integer;

	@Column()
	chargeId!: integer;

	@Column({ type: "text" })
	name!: string;

	@Column()
	expirationDays!: integer;

	@Column()
	consumeType!: integer;

	@Column({ type: "boolean" })
	sellingAppeal!: boolean;

	@Column({ type: "boolean", default: true })
	enabled!: boolean;
}
