export const enum ResultCodes {
	UNKNOWN_ERROR = 0,
	SUCCESS = 1,
	INVALID_AIME_ID = 2,
	ID_ALREADY_REGISTERED = 3,
	BAN_SYSTEM_AND_USER_LOCK = 4,
	BAN_SYSTEM_LOCK = 5,
	BAN_USER_LOCK = 6,
	BAN_GENERIC_LOCK = 7,
	SYSTEM_AND_USER_LOCK = 8,
	SYSTEM_LOCK = 9,
	USER_LOCK = 10,
}

export const enum CommandId {
	FELICA_LOOKUP_REQUEST = 1,
	FELICA_REGISTER_REQUEST = 2,
	FELICA_LOOKUP_RESPONSE = 3,

	AIME_ACCOUNT_REQUEST = 4,
	REGISTER_AIME_ACCOUNT_REQUEST = 5,
	AIME_ACCOUNT_RESPONSE = 6,

	STATUS_LOG_REQUEST = 7,
	STATUS_LOG_RESPONSE = 8,

	AIME_LOG_REQUEST = 9,
	AIME_LOG_RESPONSE = 10,

	CAMPAIGN_INFO_REQUEST = 11,
	CAMPAIGN_INFO_RESPONSE = 12,

	CAMPAIGN_CLEAR_INFO_REQUEST = 13,
	CAMPAIGN_CLEAR_INFO_RESPONSE = 14,

	EXTENDED_ACCOUNT_REQUEST = 15,
	EXTENDED_ACCOUNT_RESPONSE = 16,

	EXTENDED_FELICA_ACCOUNT_REQUEST = 17,
	EXTENDED_FELICA_ACCOUNT_RESPONSE = 18,

	EXTENDED_AIME_LOG_REQUEST = 19,
	EXTENDED_AIME_LOG_RESPONSE = 20,

	SERVICE_HEALTH_REQUEST = 100,
	SERVICE_HEALTH_RESPONSE = 101,

	CLIENT_END_REQUEST = 102,
}

export enum LogStatus {
	NONE = 0,
	GAME_START = 1,
	GAME_CONTINUE = 2,
	GAME_END = 3,
	OTHERS = 4,
}

export const enum PortalRegistration {
	UNREGISTERED = 0,
	REGISTERED_ON_PORTAL = 1,
	LINKED_TO_ID = 2,
}

export const enum CompanyCodes {
	/** Not really, could be FeliCa Mobile. */
	INVALID = 0,
	SEGA = 1,
	BANDAI_NAMCO = 2,
	KONAMI = 3,
	TAITO = 4,
}
