import Struct from "typed-struct";

export const AimeAccountQueryStruct = new Struct("AimeAccountQuery")
	.UInt8Array("accessCode", 10)
	.UInt8("companyCode")
	.UInt8("firmwareVersion")
	.UInt32LE("serialNumber")
	.compile();

export const AimeAccountResponseStruct = new Struct("AimeAccountResponse")
	.UInt32LE("accountId")
	.UInt8("portalRegistered")
	.UInt8Array("padding", 11)
	.compile();

export const AimeAccountExtendedQueryStruct = new Struct("AimeAccountExtendedQuery")
	.UInt8Array("accessCode", 10)
	.UInt8("companyCode")
	.UInt8("readerFirmwareVersion")
	.UInt32LE("cardSerialNumber")
	.compile();

export const AimeAccountExtendedResponseStruct = new Struct("AimeAccountExtendedResponse")
	.UInt32LE("accountId")
	.UInt8("portalRegistered")
	.UInt8Array("padding", 3)
	.UInt8Array("segaIdAuthKey", 256)
	.UInt32LE("relationId1")
	.UInt32LE("relationId2")
	.compile();
