import Struct from "typed-struct";

export const StatusLogStruct = new Struct("StatusLog")
	.UInt32LE("aimeId")
	.UInt32LE("status")
	.UInt8Array("padding", 8)
	.compile();

export const AimeLogStruct = new Struct("AimeLog")
	.UInt32LE("aimeId")
	.UInt32LE("status")
	.BigUInt64LE("userId")
	.Int32LE("creditCount")
	.Int32LE("betCount")
	.Int32LE("wonCount")
	.UInt8Array("padding", 4)
	.compile();

export const ExtendedAimeLogEntryStruct = new Struct("ExtendedAimeLogEntry")
	.UInt32LE("aimeId")
	.UInt32LE("status")
	.BigUInt64LE("userId")
	.Int32LE("creditCount")
	.Int32LE("betCount")
	.Int32LE("wonCount")
	.UInt8Array("padding", 4)
	.BigUInt64LE("localTime")
	.Int32LE("tSeq")
	.UInt32LE("placeId")
	.compile();

export const ExtendedAimeLogStruct = new Struct("ExtendedAimeLog")
	.StructArray("entries", ExtendedAimeLogEntryStruct, 20)
	.UInt32LE("count")
	.UInt8Array("padding", 12)
	.compile();

export const AimeLogExtendedResponseStruct = new Struct("AimeLogExtendedResponse")
	.UInt8Array("result", 20)
	.UInt8Array("padding", 12)
	.compile();
