import { ChunithmAirPlus } from "./115-airplus";
import CreateLogCtx from "lib/logger/logger";
import type { Request, Response } from "express";

const logger = CreateLogCtx(__filename);

export class ChunithmAmazon extends ChunithmAirPlus {
	constructor(gameCode?: string, version?: string, servletName?: string) {
		super(gameCode ?? "SDBT", version ?? "130", servletName ?? "ChuniServlet");
	}

	override createGetGameSettingsApiResponse(req: Request, res: Response) {
		const resp = super.createGetGameSettingsApiResponse(req, res);

		resp.gameSetting.dataVersion = "1.30.00";

		return resp;
	}

	/**
	 * @since AMAZON
	 */
	handle_GetUserDuelApi(req: Request, res: Response) {
		throw new Error("Unimplemented");
	}

	override handle_GetUserRecentPlayerApi(req: Request, res: Response): Response {
		// ARTEMiS discord says they've never seen this in AMAZON and newer...
		logger.warn("Deprecated API method called.", {
			method: "GetUserRecentPlayerApi",
			gameCode: this.gameCode,
			version: this.version,
		});

		return super.handle_GetUserRecentPlayerApi(req, res);
	}
}
