import { ChunithmAmazonPlus } from "./135-amazonplus";
import { Config } from "lib/setup/config";
import type { Request, Response } from "express";

export class ChunithmCrystal extends ChunithmAmazonPlus {
	constructor(gameCode?: string, version?: string, servletName?: string) {
		super(gameCode ?? "SDBT", version ?? "140", servletName ?? "ChuniServlet");
	}

	override createGetGameSettingsApiResponse(req: Request, res: Response) {
		const resp = super.createGetGameSettingsApiResponse(req, res);

		resp.gameSetting.dataVersion = "1.40.00";

		return resp;
	}

	/**
	 * @since CRYSTAL
	 */
	handle_GetUserTeamApi(req: Request, res: Response) {
		// TODO
		const teamName = Config.CHUNITHM_CONFIG.MODS.TEAM_NAME;

		if (!teamName) {
			return res.send({
				userId: req.safeBody.userId,
				teamId: "0",
			});
		}

		return res.send({
			userId: req.safeBody.userId,
			teamId: "1",
			teamRank: "1",
			teamName,
			userTeamPoint: {
				userId: req.safeBody.userId,
				teamId: 1,
				orderId: 1,
				teamPoint: 1,
				aggrDate: req.safeBody.playDate,
			},
		});
	}

	/**
	 * @since CRYSTAL
	 */
	handle_GetTeamCourseSettingApi(req: Request, res: Response) {
		// TODO
		return res.send({
			userId: req.safeBody.userId,
			length: "0",
			nextIndex: "0",
			teamCourseSettingList: [],
		});
	}

	/**
	 * @since CRYSTAL
	 */
	handle_GetTeamCourseRuleApi(req: Request, res: Response) {
		// TODO
		return res.send({
			userId: req.safeBody.userId,
			length: "0",
			nextIndex: "0",
			teamCourseRuleList: [],
		});
	}
}
